> For the complete documentation index, see [llms.txt](https://docs.umbraco.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.umbraco.com/umbraco-cms/develop-with-umbraco/application-code/backend-and-custom-logic/routing/request-pipeline.md).

# Routing in Umbraco

What the Umbraco Request Pipeline is

*This section describes what the Umbraco Request Pipeline is. It explains how Umbraco matches a document to a given request and how it generates a URL for a document.*

## Request pipeline

### What is the pipeline

The request pipeline is the process of building up the URL for a node and resolving a request to a specified node. It ensures that the right content is sent back.

![what is the pipeline](https://1282852327-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2FbFfxUcTsPCzuMkpCkZsT%2Fuploads%2Fgit-blob-d6f646b606f913ea3da4372faf95d225e1877e74%2Fwhat-is-the-pipeline.png?alt=media)

### Outbound vs Inbound

The pipeline works bidirectional: [**inbound**](/umbraco-cms/develop-with-umbraco/application-code/backend-and-custom-logic/routing/request-pipeline/inbound-pipeline.md) and [**outbound**](/umbraco-cms/develop-with-umbraco/application-code/backend-and-custom-logic/routing/request-pipeline/outbound-pipeline.md).

[**Outbound**](/umbraco-cms/develop-with-umbraco/application-code/backend-and-custom-logic/routing/request-pipeline/outbound-pipeline.md) is the process of building up a URL for a requested node. [**Inbound**](/umbraco-cms/develop-with-umbraco/application-code/backend-and-custom-logic/routing/request-pipeline/inbound-pipeline.md) is every request received by the web server and handled by Umbraco.

### Customizing the pipeline

This section will describe the components that you can use to modify Umbraco's request pipeline: [**IContentFinder**](/umbraco-cms/develop-with-umbraco/application-code/backend-and-custom-logic/routing/request-pipeline/icontentfinder.md) & `IUrlProvider`


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.umbraco.com/umbraco-cms/develop-with-umbraco/application-code/backend-and-custom-logic/routing/request-pipeline.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
